angular.module('policeSinner')
    .factory('DBA', function ($cordovaSQLite, $q, $ionicPlatform) {
        var self = this;

        var db = null;

        self.createDatabase = function () {
        };

        // Handle query's and potential errors
        self.query = function (query, parameters) {

            if (db == null) {
                console.log("DB IS NULL"); // Első query-nél kell ezt dobnia elvileg, utána lementi a db-t
                self.getDB(function (ret) {
                    db = ret;
                });
            }
            parameters = parameters || [];
            var q = $q.defer();

            $cordovaSQLite.execute(db, query, parameters)
                .then(function (result) {
                    q.resolve(result);
                }, function (error) {
                    console.warn('I found an error');
                    console.warn(error);
                    q.reject(error);
                });

            return q.promise;
        };

        // Proces a result set
        self.getAll = function (result) {
            var output = [];

            for (var i = 0; i < result.rows.length; i++) {
                output.push(result.rows.item(i));
            }
            return output;
        };

        // Proces a single result
        self.getFirst = function (result) {
            var output = null;
            output = angular.copy(result.rows.item(0));
            return output;
        };

        self.getDB = function (callback) {
            $ionicPlatform.ready(function () {
                var db = null;
                if (window.cordova) {
                    // App syntax
                    callback(window.sqlitePlugin.openDatabase({name: "policeSinner.db", location: "default"}));
                } else {
                    // Ionic serve syntax
                    callback(window.openDatabase("policeSinner.db", "1.0", "", -1));
                }
            });
        };

        return self;
    });