/**
 * Created by lcsoka on 31/05/16.
 */
var PoliceSinner = PoliceSinner || {};

PoliceSinner.game = new Phaser.Game({
	"width": window.innerWidth,
	"height": window.innerHeight,
	"render": Phaser.AUTO,
	"resolution": window.devicePixelRatio,
	"parent": "game"
});

PoliceSinner.sleep = function () {
	var state = this.game.state.current;
	var obj = {
		state: state,
		data: this.game.state.states[state].serialize()
	};
	OffApi.setProp(JSON.stringify(obj));
	//var item=window.localStorage.setItem('PoliceSinner', ,item);
	console.log("Sleep data: " + JSON.stringify(obj));
	//alert('save');
};

PoliceSinner.wakeup = function (data) {
	var obj = null;
	try {
		obj = JSON.parse(data);
	} catch (e) {

	}
	if (!obj) {
		// alert("no prop data");
		return;
	} else {
		// alert("Van prop data");
	}
	var state = this.game.state.states[obj.state];
	state.unserialize.call(state, obj.data);
};

PoliceSinner.game.state.add('Boot', PoliceSinner.Boot);
PoliceSinner.game.state.add('Preload', PoliceSinner.Preload);
PoliceSinner.game.state.add('Menu', PoliceSinner.Menu);
PoliceSinner.game.state.add('Game', PoliceSinner.Game);

PoliceSinner.game.state.start('Boot');

// CONSTANTS

const FELELSZ = 0;
const MERSZ = 1;
const SZEXPOZ = 2;
const TABU = 3;
const ALLATIHANGOK = 4;
const START = 5;
const END = 6;

const teamImages = [
	"img/menu/babuk/select.png",
	"img/menu/babuk/nemek.png",
	"img/menu/babuk/sziv.png",
	"img/menu/babuk/alarc.png",
	"img/menu/babuk/cipo.png",
	"img/menu/babuk/bilincs.png"
];


var canScroll = true;
var glideInit = false;

// Converts from degrees to radians.
Math.radians = function (degrees) {
	return degrees * Math.PI / 180;
};

// Converts from radians to degrees.
Math.degrees = function (radians) {
	return radians * 180 / Math.PI;
};

/* Load templates*/
$(function () {
	$('#menu').load('templates/menu.html');
	$('#team-select').load('templates/team-select.html');
	$('#parfumok').load('templates/parfumok.html');
	$('#game-overlay').load('templates/game-overlay.html');
	$('#popup').load('templates/popup.html');
	$('#popup-animal').load('templates/popup-animal.html');
	$('#exit-popup').load('templates/exit-popup.html');
	$('#error-popup').load('templates/error-popup.html');
	$('#new-menu').load('templates/new-menu.html');
	$('#info').load('templates/info.html');
});

$(document).ready(function () {
	$('#parfumok').addClass("hidden");
});

function resetTeamSelect() {
	$('#team-select').html("");
	$('#team-select').load('templates/team-select.html');
}

function greyBody() {
	$("body").toggleClass("greyed");
}

function showPopup() {
	$('#popup').show(0, function () {
		$('#popup .wrapper').removeClass('hide');
	});
}

function showPopupAnimal() {
	toggleClick();
	$('#popup-animal').show(0, function () {
		$('#popup-animal .wrapper').removeClass('hide');
		setTimeout(function () {
			toggleClick();
			var deviceOSVersion = device.version;

			var ver = parseInt(deviceOSVersion);
			if (ver <= 5) {
				// Android 5.0 alatt fusson le
				calcHack();
			}

		}, 1000);
	});
}

function showExitPopup() {
	$('#exit-popup').show(0, function () {
		$('#exit-popup .wrapper').removeClass('hide');
	});
}

function hidePopup() {
	$('#popup .wrapper').addClass('hide');
	$("#popup .task .tabus").html("");
	setTimeout(function () {
		$('#popup').hide();
	}, 300);
}

function hidePopupAnimal() {
	$('#popup-animal .wrapper').addClass('hide');
	$("#popup-animal .task .tabus").html("");
	setTimeout(function () {
		$('#popup-animal').hide();
	}, 300);
}

function hideExitPopup() {
	$('#exit-popup .wrapper').addClass('hide');
	setTimeout(function () {
		$('#exit-popup').hide();
	}, 300);
}

function popupParams(type, description, task, points, tabus) {

	var title = type;

	if (type == "szexpoz") {
		title = "szexpóz";
	}
	$("#popup .type .title").html(title);
	$("#popup .task .description").html(description[type]);
	$("#popup .type .image").attr("class", "image " + type);
	$("#popup .task .task").html(task);
	$("#popup .task .point").html(points);

	if (tabus != null) {
		var str = "";
		for (var i = 0; i < tabus.length; i++) {
			if (i < (tabus.length - 1)) {
				str += tabus[i] + ", "
			} else {
				str += tabus[i];
			}
		}
		$("#popup .task .tabus").html(str);
	}

	showPopup();

}

function popupParamsAnimal(type, task, points, currentSound, callback) {
	$("#popup-animal .type .image").attr("class", "image " + type);
	$("#popup-animal .task .point").html(points);
	$("#popup-animal .sounds").html("");

	for (var i in task) {
		var snd = task[i].text;
		$("#popup-animal .sounds").append("<div class='sound' data-id='" + task[i].audio + "'>" + snd + "</div>")
	}

	$("#popup-animal .sound").unbind("click");


	function clickOnSound() {
		var selected = $(this).attr("data-id");
		console.log(currentSound + " " + selected);
		callback(selected == currentSound);
	}

	$("#popup-animal .sound").bind("click", clickOnSound);

	showPopupAnimal();

}

function complete(callback) {
	$("#popup .completed-ribbon").toggleClass("visible");
	setTimeout(function () {
		$("#popup .completed-ribbon").toggleClass("visible");
		callback();
	}, 2000)
}

function pass(callback) {
	$("#popup .pass-ribbon").toggleClass("visible");
	$("body").toggleClass("greyed");
	setTimeout(function () {
		$("#popup .pass-ribbon").toggleClass("visible");
		$("body").toggleClass("greyed");
		callback();
	}, 2000)
}

function win(callback) {
	$("#popup-animal .win-ribbon").toggleClass("visible");
	setTimeout(function () {
		$("#popup-animal .win-ribbon").toggleClass("visible");
		callback();
	}, 2000)
}

function lose(callback) {
	$("#popup-animal .lose-ribbon").toggleClass("visible");
	$("body").toggleClass("greyed");
	setTimeout(function () {
		$("#popup-animal .lose-ribbon").toggleClass("visible");
		$("body").toggleClass("greyed");
		callback();
	}, 2000)
}

function toggleClick() {
	$("#disable-click").toggleClass("hidden");
}


function showError(msg) {
	$('#error-popup').show(0, function () {
		$('#error-popup .task').html(msg);
		$('#error-popup .wrapper').removeClass('hide');
	});

	$('#error-popup .action-buttons .ok').click(function () {
		hideError();
	});

}

function hideError() {
	$('#error-popup .wrapper').addClass('hide');
	setTimeout(function () {
		$('#error-popup').hide();
	}, 300);
}
$(function() {
	// polyCalc.run();
	// window.dotheCalc();
});
// $(window).resize(function() {
// 	polyCalc.run();
// });