angular.module('ui.rCalendar', [])
  .constant('calendarConfig', {
    formatDay: 'dd',
    formatDayHeader: 'EEE',
    formatDayTitle: 'MMMM dd, yyyy',
    formatWeekTitle: 'MMMM yyyy, Week w',
    formatMonthTitle: 'yyyy. MMMM',
    formatWeekViewDayHeader: 'EEE d',
    formatHourColumn: 'ha',
    calendarMode: 'month',
    showWeeks: false,
    showEventDetail: true,
    startingDay: 0,
    eventSource: null,
    queryMode: 'remote'
  })
  .directive('calendar', function () {
    'use strict';
    return {
      restrict: 'EA',
      replace: true,
      templateUrl: 'lib/calendar/views/calendar.html',
      scope: {
        calendarMode: '=',
        rangeChanged: '&',
        eventSelected: '&',
        timeSelected: '&'
      },
      require: ['calendar', '?^ngModel'],
      controller: 'ui.rCalendar.CalendarController',
      link: function (scope, element, attrs, ctrls) {
        var calendarCtrl = ctrls[0], ngModelCtrl = ctrls[1];

        if (ngModelCtrl) {
          calendarCtrl.init(ngModelCtrl);
        }

        scope.$on('changeDate', function (event, direction) {
          calendarCtrl.move(direction);
        });

        scope.$on('eventSourceChanged', function (event, value) {
          calendarCtrl.onEventSourceChanged(value);
        });
      }
    };
  });








